import click
from click.decorators import pass_context
from flask.cli import with_appcontext
from flask_migrate import upgrade

from flaschengeist.controller import pluginController
from flaschengeist.utils.hook import Hook


@click.command()
@with_appcontext
@pass_context
@Hook("plugins.installed")
def install(ctx: click.Context):
    plugins = pluginController.get_enabled_plugins()

    # Install database
    upgrade(revision="flaschengeist@head")

    # Install plugins
    for plugin in plugins:
        plugin = pluginController.install_plugin(plugin.name)
        pluginController.enable_plugin(plugin.id)
